"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var debug_1 = __importDefault(require("./debug"));
var path_1 = __importDefault(require("path"));
var child_process_1 = require("child_process");
var signale_1 = __importDefault(require("signale"));
var chalk_1 = __importDefault(require("chalk"));
var util_1 = require("util");
var cosmiconfig_1 = require("cosmiconfig");
var micromatch_1 = __importDefault(require("micromatch"));
var listr2_1 = require("listr2");
var fs_1 = __importDefault(require("fs"));
var utils_1 = require("./utils");
var inquirer_1 = __importDefault(require("inquirer"));
var configExplore = (0, cosmiconfig_1.cosmiconfig)('diffrun');
var getChangeset = function () { return __awaiter(void 0, void 0, void 0, function () {
    var repoInfo, commonGitDir, origHeadFilePath, headFilePath, reversions, stdout, error_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                (0, debug_1.default)('get git changeset');
                return [4 /*yield*/, (0, utils_1.getRepoInfo)()];
            case 1:
                repoInfo = _a.sent();
                (0, debug_1.default)('repo info:', JSON.stringify(repoInfo, null, 2));
                if (!!repoInfo.sha) return [3 /*break*/, 2];
                signale_1.default.info('No reversion found in current repo');
                return [2 /*return*/, []];
            case 2:
                commonGitDir = repoInfo.commonGitDir;
                origHeadFilePath = path_1.default.resolve(commonGitDir, 'ORIG_HEAD');
                headFilePath = path_1.default.resolve(commonGitDir, 'HEAD');
                reversions = [];
                if (fs_1.default.existsSync(headFilePath)) {
                    reversions.push('HEAD');
                }
                else {
                    reversions.push(repoInfo.sha);
                }
                if (fs_1.default.existsSync(origHeadFilePath)) {
                    reversions.unshift('ORIG_HEAD');
                }
                _a.label = 3;
            case 3:
                _a.trys.push([3, 5, , 6]);
                return [4 /*yield*/, (0, util_1.promisify)(child_process_1.exec)("git diff-tree -r --name-only --no-commit-id ".concat(reversions.join(' ')))];
            case 4:
                stdout = (_a.sent()).stdout;
                return [2 /*return*/, stdout.trim().split('\n')];
            case 5:
                error_1 = _a.sent();
                signale_1.default.error('get changeset error: %s', chalk_1.default.red(error_1.message));
                return [2 /*return*/, []];
            case 6: return [2 /*return*/];
        }
    });
}); };
var diffRun = function (options) {
    if (options === void 0) { options = {}; }
    return __awaiter(void 0, void 0, void 0, function () {
        var _a, cwd, configPath, version, _b, auto, searchResult, config, configChain_1, changeset_1, task, shouldRun, result, error_2;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    (0, debug_1.default)('diff-run started');
                    _a = options.cwd, cwd = _a === void 0 ? process.cwd() : _a, configPath = options.path, version = options.version, _b = options.auto, auto = _b === void 0 ? true : _b;
                    if (!configPath) return [3 /*break*/, 2];
                    return [4 /*yield*/, configExplore.load(configPath)];
                case 1:
                    searchResult = _c.sent();
                    return [3 /*break*/, 4];
                case 2: return [4 /*yield*/, configExplore.search()];
                case 3:
                    searchResult = _c.sent();
                    _c.label = 4;
                case 4:
                    if (!!searchResult) return [3 /*break*/, 5];
                    process.exit(0);
                    return [3 /*break*/, 13];
                case 5:
                    config = searchResult.config;
                    configChain_1 = Array.isArray(config) ? config : [config];
                    return [4 /*yield*/, getChangeset()];
                case 6:
                    changeset_1 = _c.sent();
                    task = new listr2_1.Listr([
                        {
                            title: 'Running diff-run tasks',
                            task: function (_, task) {
                                return task.newListr(configChain_1.map(function (config, index) {
                                    return {
                                        title: "Task ".concat(index + 1),
                                        exitOnError: true,
                                        task: function (_, task) {
                                            return task.newListr(Object.keys(config).map(function (pattern) {
                                                return {
                                                    title: pattern,
                                                    skip: function () {
                                                        var matches = (0, micromatch_1.default)(changeset_1, pattern, {
                                                            cwd: cwd,
                                                            dot: true,
                                                            matchBase: !pattern.includes('/'),
                                                        });
                                                        return !matches.length;
                                                    },
                                                    exitOnError: true,
                                                    task: function (_, task) { return __awaiter(void 0, void 0, void 0, function () {
                                                        var commands;
                                                        return __generator(this, function (_a) {
                                                            commands = config[pattern];
                                                            commands = Array.isArray(commands)
                                                                ? commands
                                                                : [commands];
                                                            return [2 /*return*/, task.newListr(commands.map(function (command) {
                                                                    return {
                                                                        title: command,
                                                                        task: function () { return __awaiter(void 0, void 0, void 0, function () {
                                                                            return __generator(this, function (_a) {
                                                                                switch (_a.label) {
                                                                                    case 0: return [4 /*yield*/, (0, util_1.promisify)(child_process_1.exec)(command)];
                                                                                    case 1:
                                                                                        _a.sent();
                                                                                        return [2 /*return*/];
                                                                                }
                                                                            });
                                                                        }); },
                                                                    };
                                                                }), {
                                                                    concurrent: false,
                                                                })];
                                                        });
                                                    }); },
                                                };
                                            }), {
                                                concurrent: true,
                                            });
                                        },
                                    };
                                }), {
                                    concurrent: false,
                                });
                            },
                        },
                    ]);
                    shouldRun = false;
                    if (!auto) return [3 /*break*/, 7];
                    shouldRun = true;
                    return [3 /*break*/, 9];
                case 7: return [4 /*yield*/, inquirer_1.default.prompt({
                        type: 'confirm',
                        name: 'run',
                        message: 'Run diff-run tasks right now?',
                        default: true,
                    })];
                case 8:
                    result = _c.sent();
                    shouldRun = result.run;
                    _c.label = 9;
                case 9:
                    _c.trys.push([9, 12, , 13]);
                    (0, debug_1.default)("Running ".concat(chalk_1.default.blueBright('diff-run@%s')), version);
                    if (!shouldRun) return [3 /*break*/, 11];
                    return [4 /*yield*/, task.run()];
                case 10:
                    _c.sent();
                    _c.label = 11;
                case 11: return [3 /*break*/, 13];
                case 12:
                    error_2 = _c.sent();
                    return [3 /*break*/, 13];
                case 13: return [2 /*return*/];
            }
        });
    });
};
exports.default = diffRun;
